import { Client, Protos, Dicts } from "./wsclient/wsclient";
import { toj } from "../common/util";

const localStorage: Storage = cc.sys.localStorage
declare global {
    interface Window {
        // pomelo: Client,
        kefu: Client
    }
}

function initPomelo() {
    function protosGetter(): Protos {
        let protosStr = localStorage.getItem('protos');
        if (!protosStr) {
            return;
        }
        return toj(protosStr)
    }
    function protosSetter(protos: Protos) {
        localStorage.setItem('protos', JSON.stringify(protos));
    }

    function dictsGetter(): Dicts {
        let str = localStorage.getItem('dicts');
        if (!str) {
            return;
        }
        return toj(str)
    }

    function dictsSetter(dicts: Dicts) {
        localStorage.setItem('dicts', JSON.stringify(dicts));
    }

    return new Client("pomelo", { protosSetter, protosGetter, dictsGetter, dictsSetter })
}

function initKefu() {
    function protosGetter(): Protos {
        let protosStr = localStorage.getItem('kefu_protos');
        if (!protosStr) {
            return;
        }
        return toj(protosStr)
    }
    function protosSetter(protos: Protos) {
        localStorage.setItem('kefu_protos', JSON.stringify(protos));
    }

    function dictsGetter(): Dicts {
        let str = localStorage.getItem('kefu_dicts');
        if (!str) {
            return;
        }
        return toj(str)
    }

    function dictsSetter(dicts: Dicts) {
        localStorage.setItem('kefu_dicts', JSON.stringify(dicts));
    }

    return new Client("kefu", { protosSetter, protosGetter, dictsGetter, dictsSetter })
}



export = function () {
    // window.chat.pomelo = initPomelo();
    window.kefu = initKefu();
}
