"use strict";
cc._RF.push(module, '11cb5fddFVCXYabS5QZGntW', 'wsclient');
// Script/pomelo/wsclient/wsclient.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("../events/events");
var protobuf_1 = require("../protobuf/protobuf");
var protocol_1 = require("../protocol/protocol");
var util_1 = require("../../common/util");
var JS_WS_CLIENT_TYPE = 'js-websocket';
var JS_WS_CLIENT_VERSION = '0.0.1';
var DEFAULT_MAX_RECONNECT_ATTEMPTS = 10;
var RES_OK = 200;
var RES_FAIL = 500;
var RES_OLD_CLIENT = 501;
var gapThreshold = 100;
var PrettyConsole = /** @class */ (function () {
    function PrettyConsole(name) {
        this._name = name;
    }
    PrettyConsole.prototype.log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift('[' + this._name + '] ');
        console.log.apply(console, args);
    };
    PrettyConsole.prototype.info = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return this.log.apply(this, args);
    };
    PrettyConsole.prototype.debug = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift('[' + this._name + '] ');
        console.debug.apply(console, args);
    };
    PrettyConsole.prototype.warn = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift('[' + this._name + '] ');
        console.warn.apply(console, args);
    };
    PrettyConsole.prototype.error = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.unshift('[' + this._name + '] ');
        console.error.apply(console, args);
    };
    return PrettyConsole;
}());
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    function Client(name, params) {
        var _this = _super.call(this) || this;
        _this.getNextSeqId = function () {
            _this._nextSeqId++;
            return _this._nextSeqId;
        };
        _this.lzw_decode = function (s) {
            var dict = {};
            var data = (s + "").split("");
            var currChar = data[0];
            var oldPhrase = currChar;
            var out = [currChar];
            var code = 256;
            var phrase;
            for (var i = 1; i < data.length; i++) {
                var currCode = data[i].charCodeAt(0);
                if (currCode < 256) {
                    phrase = data[i];
                }
                else {
                    phrase = dict[currCode] ? dict[currCode] : (oldPhrase + currChar);
                }
                out.push(phrase);
                currChar = phrase.charAt(0);
                dict[code] = oldPhrase + currChar;
                code++;
                oldPhrase = phrase;
            }
            return out.join("");
        };
        _this.init = function (params) {
            _this._clientParams = params;
            if (!_this._clientParams.maxReconnectAttempts) {
                _this._clientParams.maxReconnectAttempts = DEFAULT_MAX_RECONNECT_ATTEMPTS;
            }
            var clientName = _this._name;
            _this._log = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var l = params.customLog || this._prettyConsole.info;
                var m = args.join(' ').toString();
                l("" + clientName + m);
            };
            _this._handshakeBuffer.user = params.user;
            // if (params.encrypt) {
            //     useCrypto = true;
            //     rsa.generate(1024, "10001");
            //     let data = {
            //         rsa_n: rsa.n.toString(16),
            //         rsa_e: rsa.e
            //     }
            //     handshakeBuffer.sys.rsa = data;
            // }
            _this._log("pomelo\u5F00\u59CB\u8FDE\u63A5");
            _this.connect();
        };
        _this.decode = function (data) {
            //probuff decode
            var msg = protocol_1.Message.decode(data);
            if (msg.id > 0) {
                msg.route = _this._routeMap[msg.id];
                delete _this._routeMap[msg.id];
                if (!msg.route) {
                    return;
                }
            }
            msg.body = _this.deCompose(msg);
            return msg;
        };
        _this.encode = function (reqId, route, msg) {
            var type = reqId ? protocol_1.Message.TYPE_REQUEST : protocol_1.Message.TYPE_NOTIFY; //compress message by protobuf
            if (_this._protobuf && _this._clientProtos[route]) {
                msg = _this._protobuf.encode(route, msg);
            }
            else {
                msg = protocol_1.Protocol.strencode(JSON.stringify(msg));
            }
            var compressRoute = false;
            var _route = route;
            if (_this._dict && _this._dict[route]) {
                _route = _this._dict[route];
                compressRoute = true;
            }
            return protocol_1.Message.encode(reqId, type, compressRoute, _route, msg);
        };
        _this.connect = function () {
            var params = _this._protoDictParms;
            //获取protos
            var protos = params.protosGetter();
            if (!_this._protoVersion) {
                _this._protoVersion = (protos && protos.version) || "";
                _this._serverProtos = (protos && protos.server) || {};
                _this._clientProtos = (protos && protos.client) || {};
                _this._protobuf = new protobuf_1.Protobuf({ encoderProtos: _this._clientProtos, decoderProtos: _this._serverProtos });
            }
            //获取dicts
            var dicts = params.dictsGetter();
            if (!_this._dictVersion) {
                _this._dictVersion = (dicts && dicts.version) || "";
                _this._dict = (dicts && dicts.routeToCode) || {};
                _this._abbrs = (dicts && dicts.codeToRoute) || {};
            } //Set protoversion
            _this._handshakeBuffer.sys.protoVersion = _this._protoVersion;
            _this._handshakeBuffer.sys.dictVersion = _this._dictVersion;
            // this._socket = new WebSocket(this._clientParams.url, cc.url.raw("resources/admin.120b60.cn"));
            _this._socket = new WebSocket(_this._clientParams.url);
            _this._socket.binaryType = 'arraybuffer';
            _this._socket.onopen = _this.onopen;
            _this._socket.onmessage = _this.onmessage;
            _this._socket.onerror = _this.onerror;
            _this._socket.onclose = _this.onclose;
        };
        //主动断开连接
        _this.disconnect = function () {
            var socket = _this._socket;
            if (_this._socket) {
                if (socket.disconnect)
                    socket.disconnect();
                if (socket.close)
                    socket.close(); // console.log('disconnect');
                _this._socket = null;
            }
            if (_this._heartbeatId) {
                clearTimeout(_this._heartbeatId);
                _this._heartbeatId = null;
            }
            if (_this._heartbeatTimeoutId) {
                clearTimeout(_this._heartbeatTimeoutId);
                _this._heartbeatTimeoutId = null;
            }
        };
        //清理重连
        _this.reset = function () {
            _this._nextSeqId = 0;
            _this._reconnect = false;
            _this._reconnectionDelay = 1000 * 5;
            _this._reconnectAttempts = 0;
            if (_this._reconncetTimer) {
                clearTimeout(_this._reconncetTimer);
                _this._reconncetTimer = undefined;
            }
        };
        //发送request请求
        _this.request = function (route, msg, cb) {
            msg = msg || {};
            route = route || msg.route;
            if (!route) {
                return;
            }
            _this._reqId++;
            _this.sendMessage(_this._reqId, route, msg);
            _this._callbacks[_this._reqId] = cb;
            _this._routeMap[_this._reqId] = route;
        };
        _this.notify = function (route, msg) {
            msg = msg || {};
            _this.sendMessage(0, route, msg);
        };
        _this.sendMessage = function (reqId, route, msg) {
            // if (useCrypto) {
            //     msg = JSON.stringify(msg);
            //     let sig = rsa.signString(msg, "sha256");
            //     msg = toj(msg);
            //     msg['__crypto__'] = sig;
            // }
            if (console) {
                console.log("====>" + route + "::" + JSON.stringify(msg));
            }
            msg = _this.encode(reqId, route, msg);
            var packet = protocol_1.Package.encode(protocol_1.Package.TYPE_DATA, msg, _this.getNextSeqId());
            _this.send(packet);
        };
        _this.send = function (packet) {
            if (_this._socket) {
                _this._socket.send(packet.buffer);
            }
        };
        //处理心跳消息
        _this.heartbeat = function (data) {
            _this._prettyConsole.debug("wsclient recv heartbeat");
            if (!_this._heartbeatInterval) {
                // no heartbeat
                return;
            }
            if (_this._heartbeatTimeoutId) {
                clearTimeout(_this._heartbeatTimeoutId);
                _this._heartbeatTimeoutId = null;
            }
            if (_this._heartbeatId) {
                // already in a heartbeat interval
                return;
            }
            _this._heartbeatId = setTimeout(function () {
                _this._heartbeatId = null;
                _this._prettyConsole.debug("wsclient send heartbeat", _this._heartbeatTimeout);
                var obj = protocol_1.Package.encode(protocol_1.Package.TYPE_HEARTBEAT, undefined, _this.getNextSeqId());
                _this.send(obj);
                _this._nextHeartbeatTimeout = Date.now() + _this._heartbeatTimeout;
                _this._heartbeatTimeoutId = setTimeout(_this.heartbeatTimeoutCb, _this._heartbeatTimeout);
            }, _this._heartbeatInterval);
        };
        //处理心跳超时
        _this.heartbeatTimeoutCb = function () {
            var gap = _this._nextHeartbeatTimeout - Date.now();
            if (gap > gapThreshold) {
                _this._heartbeatTimeoutId = setTimeout(_this.heartbeatTimeoutCb, gap);
            }
            else {
                _this._prettyConsole.error('server heartbeat timeout');
                _this.emit('heartbeat timeout');
                _this.disconnect();
            }
        };
        //处理handshake消息
        _this.handshake = function (data) {
            _this._log("pomelo handshake end");
            var resdata = util_1.toj(_this.lzw_decode(protocol_1.Protocol.strdecode(data)));
            if (resdata.code === RES_OLD_CLIENT) {
                _this.emit('error', 'client version not fullfill');
                return;
            }
            if (resdata.code !== RES_OK) {
                _this.emit('error', 'handshake fail');
                return;
            }
            _this.handshakeInit(resdata);
            var obj = protocol_1.Package.encode(protocol_1.Package.TYPE_HANDSHAKE_ACK, undefined, _this.getNextSeqId());
            _this.send(obj);
            if (_this._clientParams.initCallback) {
                _this._clientParams.initCallback();
            }
        };
        //处理普通消息
        _this.onData = function (data) {
            var msg = data;
            msg = _this.decode(msg);
            _this.processMessage(msg);
        };
        //onKick
        _this.onKick = function (data) {
            data = util_1.toj(protocol_1.Protocol.strdecode(data));
            _this.emit('onKick', data);
        };
        _this.initHandler = function () {
            _this._handlers = {};
            _this._handlers[protocol_1.Package.TYPE_HANDSHAKE] = _this.handshake;
            _this._handlers[protocol_1.Package.TYPE_HEARTBEAT] = _this.heartbeat;
            _this._handlers[protocol_1.Package.TYPE_DATA] = _this.onData;
            _this._handlers[protocol_1.Package.TYPE_KICK] = _this.onKick;
        };
        _this.processPackage = function (msgs) {
            if (Array.isArray(msgs)) {
                for (var i = 0; i < msgs.length; i++) {
                    var msg = msgs[i];
                    _this._handlers[msg.type](msg.body);
                }
            }
            else {
                _this._handlers[msgs.type](msgs.body);
            }
        };
        _this.processMessage = function (msg) {
            if (console) {
                console.log("<====" + msg.route + "::" + JSON.stringify(msg.body));
            }
            if (!msg.id) {
                // server push message
                _this.emit(msg.route, msg.body);
                return;
            }
            //if have a id then find the callback function with the request
            var cb = _this._callbacks[msg.id];
            delete _this._callbacks[msg.id];
            if (typeof cb !== 'function') {
                return;
            }
            cb(msg.body);
            return;
        };
        _this.deCompose = function (msg) {
            var route = msg.route;
            //Decompose route from dict
            if (msg.compressRoute) {
                if (!_this._abbrs[route]) {
                    return {};
                }
                route = msg.route = _this._abbrs[route];
            }
            var strroute = route;
            if (_this._protobuf && _this._serverProtos[route]) {
                return _this._protobuf.decode /*Str*/(strroute, msg.body);
            }
            else {
                return util_1.toj(protocol_1.Protocol.strdecode(msg.body));
            }
        };
        _this.handshakeInit = function (data) {
            if (data.sys && data.sys.heartbeat) {
                _this._heartbeatInterval = data.sys.heartbeat * 1000; // heartbeat interval
                _this._heartbeatTimeout = _this._heartbeatInterval * 2; // max heartbeat timeout
            }
            else {
                _this._heartbeatInterval = 0;
                _this._heartbeatTimeout = 0;
            }
            _this.initData(data);
            if (_this._clientParams.handshakeCallback) {
                _this._clientParams.handshakeCallback(data.user);
            }
        };
        //Initilize data used in pomelo client
        _this.initData = function (data) {
            if (!data || !data.sys) {
                return;
            }
            var dictRouteToCode = data.sys.routeToCode;
            var dictCodeToRoute = data.sys.codeToRoute;
            var dictVersion = data.sys.dictVersion;
            var protos = data.sys.protos;
            var dictLocalStorage = undefined;
            //Init compress dict
            if (dictRouteToCode && dictCodeToRoute && dictVersion) {
                _this._dict = dictRouteToCode;
                _this._abbrs = dictCodeToRoute;
                dictLocalStorage = {
                    routeToCode: dictRouteToCode,
                    codeToRoute: dictCodeToRoute,
                    version: dictVersion
                };
            }
            var protosLocalStorage = undefined;
            //Init protobuf protos
            if (protos) {
                protosLocalStorage = protos;
                _this._protoVersion = protos.version || "";
                _this._serverProtos = protos.server || {};
                _this._clientProtos = protos.client || {}; //Save protobuf protos to localStorage
                if (!!_this._protobuf) {
                    _this._protobuf = new protobuf_1.Protobuf({ encoderProtos: protos.client, decoderProtos: protos.server });
                }
            }
            if (dictLocalStorage) {
                _this._protoDictParms.dictsSetter(dictLocalStorage);
                // window.localStorage.setItem('dicts', JSON.stringify(dictLocalStorage));
            }
            if (protosLocalStorage) {
                _this._protoDictParms.protosSetter(protosLocalStorage);
                // window.localStorage.setItem('protos', JSON.stringify(protosLocalStorage));
            }
        };
        //处理连接打开
        _this.onopen = function (event) {
            _this._log("pomelo onOpen");
            if (!!_this._reconnect) {
                _this.emit('reconnect');
            }
            _this.reset();
            _this._log("pomelo start handshake");
            var obj = protocol_1.Package.encode(protocol_1.Package.TYPE_HANDSHAKE, protocol_1.Protocol.strencode(JSON.stringify(_this._handshakeBuffer)));
            _this.send(obj);
        };
        //socket收到消息
        _this.onmessage = function (event) {
            _this.processPackage(protocol_1.Package.decode(event.data)); // new package arrived, update the heartbeat timeout
            if (_this._heartbeatTimeout) {
                _this._nextHeartbeatTimeout = Date.now() + _this._heartbeatTimeout;
            }
        };
        //socket onError
        _this.onerror = function (event) {
            _this.emit('io-error', event);
            _this._log("pomelo on error" + JSON.stringify(event));
            _this._prettyConsole.error('socket error: ', event);
        };
        //socket onClose
        _this.onclose = function (event) {
            _this.emit('close', event);
            _this.emit('disconnect', event);
            _this._prettyConsole.error('socket close: ', event);
            if (!!_this._clientParams.reconnect && _this._reconnectAttempts < _this._clientParams.maxReconnectAttempts) {
                _this._reconnect = true;
                _this._reconnectAttempts++;
                _this._reconncetTimer = setTimeout(function () { return _this.connect(); }, _this._reconnectionDelay);
                _this._reconnectionDelay *= 2;
            }
        };
        _this._name = name;
        _this._nextSeqId = 0;
        _this._prettyConsole = new PrettyConsole(_this._name);
        _this._protoDictParms = params;
        _this._protoVersion = undefined;
        _this._dictVersion = undefined;
        _this._reconnectionDelay = 5000;
        _this._reqId = 0;
        _this._callbacks = {};
        _this._handshakeBuffer = {
            sys: {
                type: JS_WS_CLIENT_TYPE,
                version: JS_WS_CLIENT_VERSION,
                protoVersion: "",
                dictVersion: "",
                rsa: {}
            },
            user: {}
        };
        _this.initHandler();
        _this._routeMap = {};
        return _this;
    }
    Client.prototype.socketReadyState = function () {
        if (this._socket) {
            return this._socket.readyState;
        }
        else {
            return 100;
        }
    };
    return Client;
}(events_1.EventEmitter));
exports.Client = Client;

cc._RF.pop();