"use strict";
cc._RF.push(module, 'a7459nrMRlPrLhNsT4gBbCn', 'events');
// Script/pomelo/events/events.ts

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var EventEmitter = /** @class */ (function () {
    function EventEmitter() {
        this.__callbacks = {};
    }
    EventEmitter.prototype.on = function (event, listener) {
        return this.addEventListener(event, listener);
    };
    EventEmitter.prototype.addEventListener = function (event, listener, once) {
        var arr = this.__callbacks['$' + event];
        if (!arr) {
            arr = [];
            this.__callbacks['$' + event] = arr;
        }
        arr.push({ fn: listener, once: once });
        return this;
    };
    EventEmitter.prototype.once = function (event, listener) {
        return this.addEventListener(event, listener, true);
    };
    EventEmitter.prototype._removeListener = function (event, listener) {
        if (event) {
            var callbacks = this.__callbacks['$' + event];
            if (!callbacks) {
                return this;
            }
            if (!listener) { //删除整个事件的全部监听
                delete this.__callbacks['$' + event];
                return this;
            }
            var cb = void 0;
            for (var i = 0; i < callbacks.length; i++) {
                cb = callbacks[i];
                if (cb.fn === listener) {
                    callbacks.splice(i, 1);
                    break;
                }
            }
            return this;
        }
        else {
            this.removeAllListeners();
            return this;
        }
    };
    EventEmitter.prototype.off = function (event, listener) {
        return this._removeListener(event, listener);
    };
    EventEmitter.prototype.removeListener = function (event, listener) {
        return this._removeListener(event, listener);
    };
    EventEmitter.prototype.removeEventListener = function (event, listener) {
        return this._removeListener(event, listener);
    };
    EventEmitter.prototype.removeAllListeners = function () {
        this.__callbacks = {};
    };
    EventEmitter.prototype.emit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var callbacks = this.__callbacks['$' + event];
        if (callbacks && callbacks.length) {
            callbacks = callbacks.slice(0);
            for (var i = 0; i < callbacks.length; i++) {
                callbacks[i].fn.apply(this, args.slice());
                if (callbacks[i].once) {
                    this.off(event, callbacks[i].fn);
                }
            }
        }
        return this;
    };
    EventEmitter.prototype.listeners = function (event) {
        return (this.__callbacks['$' + event] || []).map(function (e) { return e.fn; });
    };
    EventEmitter.prototype.hasListeners = function (event) {
        return !!this.listeners(event).length;
    };
    return EventEmitter;
}());
exports.EventEmitter = EventEmitter;

cc._RF.pop();